package com.sa.ibiz.demo.demo.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import lombok.Data;
import org.springframework.beans.BeanUtils;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.cglib.beans.BeanGenerator;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.FieldFill;
import java.util.Map;
import java.util.HashMap;
import org.springframework.util.StringUtils;
import com.sa.ibiz.demo.ibizutil.security.AuthenticationUser;
import java.util.Date;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import org.springframework.cglib.beans.BeanCopier;
import com.sa.ibiz.demo.ibizutil.annotation.Dict;
import com.sa.ibiz.demo.ibizutil.domain.EntityBase;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.enums.FillMode;
import com.sa.ibiz.demo.ibizutil.enums.PredefinedType;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import com.alibaba.fastjson.annotation.JSONField;


/**
 * 实体[BGYP] 数据对象
 */
@TableName(value = "T_BGYP",resultMap = "BGYPResultMap")
@JsonIgnoreProperties(ignoreUnknown = true)
@Data
public class BGYP extends EntityBase implements Serializable{

    @TableId(value= "bgypid",type=IdType.UUID)//指定主键生成策略
    private String bgypid;
    private String bgypname;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createdate;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String createman;
    private String gg;
    private Integer sl;
    private String tp;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updatedate;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String updateman;
    @Dict(dictName = "ionicdemo_YPCodelistCodeList")
    private String yplx;
    /**
     *  设置属性值[办公用品标识]
     *  @param bgypid
     */
    public void setBgypid(String bgypid){
        if(StringUtils.isEmpty(bgypid))
            bgypid=null;
        this.bgypid = bgypid;
        this.set("bgypiddirtyflag",true);
    }
    /**
     *  获取属性值[办公用品标识]
     */
    public String getBgypid(){
        return this.bgypid;
    }
    /**
     *  重置属性值[办公用品标识]
     */
    public void resetBgypid(){
        this.set("bgypiddirtyflag",false);
        this.bgypid = null;
    }
    /**
     *  设置属性值[办公用品名称]
     *  @param bgypname
     */
    public void setBgypname(String bgypname){
        if(StringUtils.isEmpty(bgypname))
            bgypname=null;
        this.bgypname = bgypname;
        this.set("bgypnamedirtyflag",true);
    }
    /**
     *  获取属性值[办公用品名称]
     */
    public String getBgypname(){
        return this.bgypname;
    }
    /**
     *  重置属性值[办公用品名称]
     */
    public void resetBgypname(){
        this.set("bgypnamedirtyflag",false);
        this.bgypname = null;
    }
    /**
     *  设置属性值[建立时间]
     *  @param createdate
     */
    public void setCreatedate(Timestamp createdate){
        this.createdate = createdate;
        this.set("createdatedirtyflag",true);
    }
    /**
     *  获取属性值[建立时间]
     */
    public Timestamp getCreatedate(){
        return this.createdate;
    }
    /**
     *  重置属性值[建立时间]
     */
    public void resetCreatedate(){
        this.set("createdatedirtyflag",false);
        this.createdate = null;
    }
    /**
     *  设置属性值[建立人]
     *  @param createman
     */
    public void setCreateman(String createman){
        if(StringUtils.isEmpty(createman))
            createman=null;
        this.createman = createman;
        this.set("createmandirtyflag",true);
    }
    /**
     *  获取属性值[建立人]
     */
    public String getCreateman(){
        return this.createman;
    }
    /**
     *  重置属性值[建立人]
     */
    public void resetCreateman(){
        this.set("createmandirtyflag",false);
        this.createman = null;
    }
    /**
     *  设置属性值[规格]
     *  @param gg
     */
    public void setGg(String gg){
        if(StringUtils.isEmpty(gg))
            gg=null;
        this.gg = gg;
        this.set("ggdirtyflag",true);
    }
    /**
     *  获取属性值[规格]
     */
    public String getGg(){
        return this.gg;
    }
    /**
     *  重置属性值[规格]
     */
    public void resetGg(){
        this.set("ggdirtyflag",false);
        this.gg = null;
    }
    /**
     *  设置属性值[数量]
     *  @param sl
     */
    public void setSl(Integer sl){
        this.sl = sl;
        this.set("sldirtyflag",true);
    }
    /**
     *  获取属性值[数量]
     */
    public Integer getSl(){
        return this.sl;
    }
    /**
     *  重置属性值[数量]
     */
    public void resetSl(){
        this.set("sldirtyflag",false);
        this.sl = null;
    }
    /**
     *  设置属性值[图片]
     *  @param tp
     */
    public void setTp(String tp){
        if(StringUtils.isEmpty(tp))
            tp=null;
        this.tp = tp;
        this.set("tpdirtyflag",true);
    }
    /**
     *  获取属性值[图片]
     */
    public String getTp(){
        return this.tp;
    }
    /**
     *  重置属性值[图片]
     */
    public void resetTp(){
        this.set("tpdirtyflag",false);
        this.tp = null;
    }
    /**
     *  设置属性值[更新时间]
     *  @param updatedate
     */
    public void setUpdatedate(Timestamp updatedate){
        this.updatedate = updatedate;
        this.set("updatedatedirtyflag",true);
    }
    /**
     *  获取属性值[更新时间]
     */
    public Timestamp getUpdatedate(){
        return this.updatedate;
    }
    /**
     *  重置属性值[更新时间]
     */
    public void resetUpdatedate(){
        this.set("updatedatedirtyflag",false);
        this.updatedate = null;
    }
    /**
     *  设置属性值[更新人]
     *  @param updateman
     */
    public void setUpdateman(String updateman){
        if(StringUtils.isEmpty(updateman))
            updateman=null;
        this.updateman = updateman;
        this.set("updatemandirtyflag",true);
    }
    /**
     *  获取属性值[更新人]
     */
    public String getUpdateman(){
        return this.updateman;
    }
    /**
     *  重置属性值[更新人]
     */
    public void resetUpdateman(){
        this.set("updatemandirtyflag",false);
        this.updateman = null;
    }
    /**
     *  设置属性值[用品类型]
     *  @param yplx
     */
    public void setYplx(String yplx){
        if(StringUtils.isEmpty(yplx))
            yplx=null;
        this.yplx = yplx;
        this.set("yplxdirtyflag",true);
    }
    /**
     *  获取属性值[用品类型]
     */
    public String getYplx(){
        return this.yplx;
    }
    /**
     *  重置属性值[用品类型]
     */
    public void resetYplx(){
        this.set("yplxdirtyflag",false);
        this.yplx = null;
    }
    /**
     * 重置当前数据对象属性值
     */
    public  void reset(){
        resetBgypid();
        resetBgypname();
        resetCreatedate();
        resetCreateman();
        resetGg();
        resetSl();
        resetTp();
        resetUpdatedate();
        resetUpdateman();
        resetYplx();
    }
     /**
     * 获取数据主键（普通主键与联合主键）
     * @return
     */
    @JsonIgnore
    public Serializable getDefaultPrimaryKey()
    {
	    //随机生成主键
         return  IdWorker.get32UUID();

    }
     /**
     * 复制当前对象数据到目标对象(粘贴重置)
     *
     * @throws Exception
     */
    public BGYP copyTo(BGYP targetEntity)
	{
		BeanCopier copier=BeanCopier.create(BGYP.class, BGYP.class, false);
		copier.copy(this, targetEntity, null);
        targetEntity.resetBgypid();
		return targetEntity;
	}
}